#include <videoencoder.h>
#include <avifile.h>
#include <aviplay.h>
#include <version.h>
#if (AVIFILE_MAJOR_VERSION == 0) && (AVIFILE_MINOR_VERSION==6) 
   #include <fourcc.h>
   #include <creators.h>
#else
   #include <aviutil.h>
#endif
#include <libmpeg3.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include <fstream>
#include "encoder-cpp.hh"
#include "gui-cpp.hh"
#include <errno.h>
#include "../libmpeg3-1.2.3/spu.h"
#include "../libmpeg3-1.2.3/subpictures.h"
#include "../src/drip.h"
#include <gdk-pixbuf/gdk-pixbuf.h>


#define APPNAME "dripencoder"
#define VERSION "0.99"
#define ENCODER_LD "DripEncoder"

#define BYTES_PER_COLOUR_OUTPOUT 3
#define LIBMPEG_COLOUR_DEPT_OUPUT MPEG3_BGR888 //MPEG3_601_BGRA8888
#define AVIFILE_COLOUR_DEPT_INPUT 24
//#define YCRCB

extern gint clipleft;
extern gint clipright;
extern gint cliptop;
extern gint clipbottom;


typedef struct _arg_parmS arg_parmS;
struct _arg_parmS {
    gint argc;
    gchar **argv;
    gint nice;
};


/* Globals */
extern gboolean encoding;
extern gboolean stopped;
extern gboolean encoding_paused;
extern pthread_t serverthread;
extern gint serverthread_id;
extern pthread_t encoderthread;
extern gint encoderthread_id;
extern pthread_t guiclientthread;
extern gint guiclientthread_id;
extern drip::gui_var gui_client;
extern gint linenr;
extern gint log_handler_encoder_id;
extern gboolean forking;
extern gboolean standalone;

/* protos */
void log_handler(glong level,const gchar *message);

