/*
 * fibmap
 * 
 * FIBMAP on linux kernels needs root, so dont use the call internally in Drip but
 * execute this separate setuid appl.
 *
 * Jarl van Katwijk, 16 jul 2001
 */

#include <fcntl.h>
#include <sys/ioctl.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#define FIBMAP     _IO(0x00,1)  /* bmap access */


int main(int argc,char** argv) {
    int fd, lba = 0;

    if(geteuid() != 0) {
        fprintf(stderr, "must be root to call FIBMAP ioctl, make sure this binairy has been installed with setuid 0\n");
        return EXIT_FAILURE;
    }

    if (argc != 2) {
        printf("usage: fibmap {path-to-device}\n");
        return EXIT_FAILURE;
    }

    if ((fd = open(argv[1], O_RDONLY)) < 0) {
        perror("DVD vob file");
        return EXIT_FAILURE;
    }
    if (ioctl(fd, FIBMAP, &lba) != 0) {
        perror("Ioctl FIBMAP");
        close(fd);
        return EXIT_FAILURE;

    }

    /* put result into pipe */
    printf("%i\n",lba);

    /* Clean & Exit */
    close(fd);
    return EXIT_SUCCESS;
}

