#include <gtk/gtk.h>
#include "glib.h"
#include <gdk-pixbuf/gdk-pixbuf.h>



#ifndef DRIP
#define DRIP

#define DRIP_LD "Drip"
#define DEBUG            /* Enables debug logging to ~/.drip.log */
// #define LM_SENSORS       /* Enables lm-sensors monitoring, and pauses Drip if CPU > 50deg celcius */

typedef struct _drip_config drip_config;
// TODO: all config in one struct seems not to be perfect...
struct _drip_config {
    GString *DVDdevice;
    GString *DVDsource;
    GString *DIVXfile;
    gboolean useDVDdevice;
    glong maxsize;
    glong width;
    glong height;
    gboolean honor_aspect;
    gfloat aspect;
    gboolean hyper_zoom;
    guint video_bitrate;
    guint video_stream;
    gint audio_bitrate; /* -1 = auto */
    guint audio_stream;
    gint codec;    /* 0 = high_motion, 1 = low_motion, 2 = OpenDIVX */
    gboolean autoclip;
    guint cliptop;
    guint clipbottom;
    guint clipright;
    guint clipleft;
    guint blurradius;
    gboolean eject_dvdrom;
    gboolean use_dvddb;
    gint nice;
    gint cpus;
    gboolean full_movie_rip_mode;
    gboolean encode;
    GString *track_dir;
    GString *CACHElocation;
    gboolean cache;
    gboolean cache_delete_on_exit;
    gboolean done_warning;
    guint audio_channels_in_dvd;
    GString *audio_channel_names[8];
    guint subpictures_in_dvd;
    GString *subpicture_names[32];
    gint subpicture_stream;
    GString* clutfile;
    gboolean create_iso;

    GString* DVDvolumeid;
    GString* DVDpublisher;
    GString* DVDpreparer;
    GString* DVDcreationdate;
    glong DVDvolumesize_MB;
};

typedef struct _rip rip;
struct _rip {
    gchar *dir;
    gchar *track;
    guint nr;
};

extern drip_config Config;
extern GString *status_action;
extern guint status_perc;
extern GtkWidget *appbar1;
extern gboolean converting;
extern guint log_handler_drip_id;
extern GtkWidget *textscreen;
extern gboolean corba;
extern gint log_file;
extern GtkWidget *gpixmap;
extern GtkWidget *hbox_main;
extern gpointer currentframebuffer;

#endif

#ifdef __cplusplus
extern "C"
#endif
void log_handler(const gchar *log_domain,GLogLevelFlags log_level,const gchar *message,gpointer user_data);
int mpeg2divx(drip_config *Config,int mpegfiles,char *files[]);
gchar* detect_dvdrom(void);
void drip_init(void);

/* encoding time passed */
extern gboolean encoding_time;
/* iso making flag */
extern gboolean making_iso;
